#pragma once

#include <string>
#include <vector>
#include <glm/glm.hpp>
#include <avk/buffer.hpp>

struct DrawCallData
{
  std::vector<glm::vec3> mPositions;
  std::vector<glm::vec2> mTexCoords;
  std::vector<glm::vec3> mNormals;
  std::vector<glm::vec3> mTagents;
  std::vector<glm::vec3> mBitangents;
  std::vector<uint32_t> mIndices;

  avk::buffer mPositionsBuffer;
  avk::buffer mTexCoordsBuffer;
  avk::buffer mNormalsBuffer;
  avk::buffer mTagentsBuffer;
  avk::buffer mBitangentsBuffer;
  avk::buffer mIndexBuffer;

  int mMaterialIndex;
  int mTextureIndex;
};

struct Scene
{
  static Scene load(std::string path, avk::queue *queue);

  std::vector<DrawCallData> mDrawCalls;
  std::vector<avk::image_sampler> mImageSamplers;
  avk::buffer mMaterialBuffer;
};