#pragma once

#include <auto_vk_toolkit.hpp>
#include <span>

#include "scene.h"

struct Shadows
{
  static Shadows create(std::span<glm::vec4> lightPositions,
      std::span<glm::vec4> lightTargets, glm::uvec2 screenRes,
      avk::queue *queue);

  void render(Scene const &scene, avk::queue *queue);

  std::vector<avk::image_view> mShadowMaps;
  std::vector<avk::framebuffer> mShadowMapFramebuffers;
  std::vector<avk::image_sampler> mShadowMapSamplers;
  std::vector<glm::mat4> mLightVPs;
  avk::buffer mLightVPsBuffer;
  avk::graphics_pipeline mShadowPipeline;
};